/*********************************************************************/
/*********************************************************************/
/*  ALUMNO: ANGEL PEDRERA PLATA..FECHA:22 DE JUNIO DE 2000           */
/*  ASIGNATURA: PROGRAMACION DE CONTROL DE PROCESOS/2 I.T.I.        */
/*  UNIVERSIDAD DE MALAGA...PROFESOR:JOSE GALINDO GOMEZ              */
/*  JUEGO CONECTOR.....BASADO EN EL FAMOSO CONECTA-4                 */
/*********************************************************************/
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <iostream.h>
#include <graphics.h>
#include <dos.h>
#include <strstream.h>
#include <raton.h>
#include <fstream.h>
#include <string.h>

#define ESC 27
#define ventanax 580
#define ventanay 420

/*PROTOTIPOS DE FUNCIONES*/

void inicializar();
void presentacion();
void cerra_graf();
void carita();
void menu();
void pinta_caja();
void pinta_tablero();
void comienza_juego(char ju);
int pon_ficha(int c, int color);
int lee_tablero(int enj);
int comprueba(int c, int f);
void victoria(int color);
void vaciar(char linea[]);
void maxitablero(int columnas, int filas);
void juega_maquina(int columnas);
void fin();
int compru_maxi(int c,int f, int maxc, int maxf);
void entrada();
void salida();
void scores();
void ganador(int puntos);
void ayuda();


/*  VARIBLES GLOBALES */

int * tablero;/* 0-->vacia; 1-->jugador A; 2-->jugador B o maquina*/
int cj,contador=0;
int pga=0,pgb=0;
int salimos=0;

struct FECHA
{
int dia,mes,ano;
};

struct JUGADOR
{
 char nombre[31];
 int puntaje;
 FECHA f_juego;
};
struct JUGADOR jugadores[4];



/*FUNCION MAIN*/

void main()
{ entrada();
  inicializar();
  presentacion();
  do
  {
  menu();
  }while(salimos!=1);
  salida();
  fin();
  cerra_graf();
}

/* ABRE ARCHIVO DE DATOS*/

void entrada()
{

  int i;
  FILE *fp;
  clrscr();
  fp=fopen("a:\\records.dat","rb");
  fread((struct JUGADOR *)jugadores,sizeof(struct JUGADOR),5,fp);
  fclose(fp);

}

/*ALMACENA ARCHIVO DE DATOS*/

void salida()
{
   FILE *fp;
   fp=fopen("a:\\records.dat","wb");
   fwrite((struct JUGADOR *)jugadores,sizeof(struct JUGADOR),5,fp);
   fclose(fp);
}

/*INICIALIZA GRFICOS*/

void inicializar()
{
  int m,n;
  int gdriver = DETECT, gmode, errorcode;
  initgraph(&gdriver, &gmode, "");       /*inicializa modo grafico*/
  errorcode = graphresult();     /*lee resultados de la inicializacion*/
  if (errorcode != grOk)  /* si ocurre un error */
  { printf("Error grafico: %s\n", grapherrormsg(errorcode));
    printf("presiona una tecla:");
    getch();
    exit(1);             /* salida con error*/
  }

}

/*PANTALLA DE PRESENTACION*/

void presentacion()
{
  int p,q;
  int sony[2][5]={{500,700,600,300,500},                 //FRECUENCIAS
		{300,500,700,600,500}};
  int duracion[2][5]={{500,500,500,500,800},           //TIEMPOS DE TONO
		    {500,500,500,500,900}};
  randomize();
  cleardevice();
  carita();
  for (p=0;p<2;p++)                 //MELODIA DE COMIENZO
   for (q=0;q<5;q++)
    {
    sound(sony[p][q]);
    delay (duracion[p][q]);
    nosound();
    }
  delay (50);
  settextstyle(0,HORIZ_DIR,8);   //define tipo de escritura
  setcolor(1);
  outtextxy(72,30,"CONECTOR");         //escribe
  setcolor(15);
  outtextxy(70,27,"CONECTOR");
  setcolor(4);
  settextstyle(0,HORIZ_DIR,2);
  outtextxy(45,415,"Realizado por: ANGEL PEDRERA PLATA");
  delay (5500);
}
/*CIERRA EL MODO GRAFICO*/

void cerra_graf()
{ closegraph();
}

/*DIBUJO DE COMIENZO*/

void carita()
{
 int tria[8]={218,307,308,160,398,307,218,307};   //coordenadas del triangulo
 int cuad[10]={278,278,338,278,338,229,278,229,278,278};
 setcolor(14);                             //pone color
 setfillstyle(6,9);                        //estilo del relleno
 fillpoly(4,tria);            //dibuja y rellena triangulo
 setcolor(14);
 setfillstyle(4,6);
 fillpoly(5,cuad);             //dibuja y rellena cuadrado
 setcolor(6);
 settextstyle(0,HORIZ_DIR,2);
 outtextxy(155,330,"UNIVERSIDAD DE MALAGA");
 outtextxy(182,355,"2 ELCA E.U.I.T.I.");
}

/*MENU DE ENTRADA*/

void menu()
{
 int a,col,fila,q,vol,columnas, filas;
 char op,ju, sale_op[3]=" ";
 int juga;
 cleardevice();
 setcolor(RED);
 setfillstyle(1,0);
 bar3d (140,170,580,310,0,0);
 a=1;
 col=160;
 fila=185;
 for (q=0;q<2;q++)
     {
     setcolor(a);
     settextstyle(0,HORIZ_DIR,5);
     outtextxy (180,90,"CONECTOR");
     settextstyle(0,HORIZ_DIR,2);
     outtextxy (col,fila,"1. JUGAR TABLERO CLASICO");
     outtextxy (col,fila+25,"2. JUGAR CUALQUIER TABLERO");
     outtextxy (col,fila+50,"3. LOS MAS LISTOS");
     outtextxy (col,fila+75,"4. COMO FUNCIONA");
     outtextxy (col,fila+100,"5. SALIR");
     a=15; col-=2; fila-=2;
     }
 outtextxy (210,333,"DECIDE: ");
 vaciar(sale_op);
 op=getch();
 sprintf(sale_op,"%c",op);
 setcolor(15);
 settextstyle(0,HORIZ_DIR,2);
 outtextxy(350,333,sale_op);
 getch();
 if (op!='6')
    {
     switch (op)
       {
	case '1': cleardevice();
		  outtextxy (30,333,"(1)UN JUGADOR---(2)DOS JUGADORES: ");
		  vaciar(sale_op);
		  ju=getch();
		  sprintf(sale_op,"%c",ju);
		  setcolor(15);
		  settextstyle(0,HORIZ_DIR,2);
		  outtextxy(600,333,sale_op);
		  getch();
		  pinta_caja();
		  pinta_tablero();
		  contador=0;
		  pga=0.0;
		  pgb=0.0;
		  comienza_juego(ju);
		  free(tablero);/*libera la memoria*/
		  break;
	case '2': cleardevice();
		  printf("                 ************************************\n\n");
		  printf("                 ***      MODO  MAXITABLERO       ***\n\n");
		  printf("                 ************************************\n\n\n\n\n");
		  printf("Introduzca n de columnas(max 80 con visualizacion):");
		  scanf("%i",&columnas);
		  printf("Introduzca n de filas(max 29 con visualizacion):");
		  scanf("%i",&filas);
		  maxitablero(columnas,filas);
		  free(tablero);/*libera la memoria*/
		  break;

	case '3': scores();  break;
	case '4': ayuda();break;
	case '5': salimos=1;break;
	default:  setcolor(10);
		  outtextxy (90,360,"FATAL ERROR!!!");
		  delay(1000);
		  break;
       }
    }
}


/*DIBUJA EL MARCO DEL JUEGO*/

void pinta_caja()
{
 cleardevice();
 setcolor(14);
 setfillstyle(1,10);
 bar(0,0,5,479);
 bar(0,0,639,5);
 bar(634,0,639,479);
 bar(0,474,639,479);
}

/*DIBUJA TABLERO*/

void pinta_tablero()
{
 setfillstyle(1,10);/*lineas horizontales*/
 bar(15,15,620,20);
 bar(15,65,620,70);
 bar(15,115,620,120);
 bar(15,165,620,170);
 bar(15,215,620,220);
 bar(15,265,620,270);
 bar(15,315,620,320);
 bar(15,365,620,370);/*lineas verticales*/
 bar(15,15,20,370);
 bar(75,15,80,370);
 bar(135,15,140,370);
 bar(195,15,200,370);
 bar(255,15,260,370);
 bar(315,15,320,370);
 bar(375,15,380,370);
 bar(435,15,440,370);
 bar(495,15,500,370);
 bar(555,15,560,370);
 bar(615,15,620,370);
 setcolor(3);
 settextstyle(0,HORIZ_DIR,5);
 outtextxy (165,385,"CONECTOR");
 setcolor(14);
 settextstyle(0,HORIZ_DIR,2);
 outtextxy(20,385,"JUGADOR A");
 setcolor(14);
 settextstyle(0,HORIZ_DIR,2);
 outtextxy(485,385,"JUGADOR B");
 setfillstyle(1,15);
 fillellipse(70,425,15,15);
 setfillstyle(1,4);
 fillellipse(555,425,15,15);
 setcolor(4);
 settextstyle(0,HORIZ_DIR,0);
 outtextxy(490,446,"P. GANADAS:");
 setcolor(15);
 settextstyle(0,HORIZ_DIR,0);
 outtextxy(19,446,"P. GANADAS:");
 setcolor(3);
 settextstyle(0,HORIZ_DIR,2);
 outtextxy(250,432,"SALIR=ESC");
}

/*FUNCION DE COMIENZO DE JUEGO*/

void comienza_juego(char ju)
{
      int x,y,c,enjuego,f,salir;
      enjuego=1;
      visualiza_raton();
      tablero=(int *)malloc(70*sizeof(int));
      if(tablero==NULL)
	 { printf("error de memoria");
	   exit(1);
	 }
      for (c=0;c<=9;c++) /*inicializa el tablero*/
      { for(f=1;f<=7;f++)
       {
       tablero[10*(f-1)+c]=0;
       }
      }

      if(ju=='2')
      { do
	{
	 lee_raton(&x,&y);
	 gotoxy(1,1);printf("--->(%i,%i);\t",x,y);/*  LINEA DE COMPROBACION*/
	 salir=lee_tablero(enjuego);
	 contador++;
	 if(contador<=69)
	  { enjuego=2;
	    salir=lee_tablero(enjuego);
	    enjuego=1;
	    contador++;
	  }
	 }while(contador<=68 && salir!=0);
	 if (contador==70)
	  { if(pga>pgb)
	    {setcolor(YELLOW);
	     settextstyle(0,HORIZ_DIR,9);
	     outtextxy(83,126,"GANA A");
	     getch();
	     ganador(pga);
	    }
	    else if(pgb>pga)
	    { setcolor(YELLOW);
	      settextstyle(0,HORIZ_DIR,9);
	      outtextxy(83,126,"TABLAS");
	      getch();
	      ganador(pgb);
	    }
	    else
	    {
	      setcolor(RED);
	      settextstyle(0,HORIZ_DIR,9);
	      outtextxy(83,126,"TABLAS");
	      getch();
	    }
	  }
      }
      else
      {   do
	  {
	     lee_raton(&x,&y);
	     /*gotoxy(1,1);printf("--->(%i,%i);\t",x,y);/*LINEA DE AJUSTE*/
	     salir=lee_tablero(enjuego);
	     contador++;
	     if(contador<=69)
	      { juega_maquina(10);
		contador++;
	      }
	  }while(contador<=68 && salir!=0);
      if (contador==70)
	 { if(pga>pgb)
	   ganador(pga);
	   else if(pgb==pga)
	    {
	      setcolor(RED);
	      settextstyle(0,HORIZ_DIR,9);
	      outtextxy(83,126,"TABLAS");
	    }
	    else
	    {
	    setcolor(YELLOW);
	    settextstyle(0,HORIZ_DIR,9);
	    outtextxy(83,126,"GANO YO!!!");
	    getch();
	    }
	 }
     }
}

/*COLOCA Y DIBUJA FICHA*/

int pon_ficha(int c, int color)
{  int f=7;
   int bien=0;
   int listo=0;
   int x,y,fila;
   oculta_raton();
   x=48+60*(c-1);
   if(x>588)
     x=588;
   if(x<48)
     x=48;
   do
   {
    if ((tablero[10*(f-1)+(c-1)])==0)
     { y=42+50*(f-1);
       setfillstyle(1,color);
       fillellipse(x,y,15,15);
       listo=1;
       if(color==15)
	 tablero[10*(f-1)+(c-1)]=1;
       else
	 tablero[10*(f-1)+(c-1)]=2;
       fila=f;
       bien=1;
     }
    f--;
    if (f<=0)
     {  listo=1;
	sound(500);
	delay(100);
	nosound();
     }
   } while(listo!=1);
   if(bien==1)
    if(comprueba((c-1),fila)==0)
	victoria(color);
   visualiza_raton();
   delay(400);
   return bien;
}


/*NOS LEE LA COLUMNA A INTRODUCIR*/

int lee_tablero(int enj)
{
   int x,y,c,ya;
   ya=0;
   if(enj==1)
   { setcolor(0);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(362,452,"");
     setcolor(15);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(170,452,"JUEGA A");
     c=15;
   }
   if(enj==2)
   {
     setcolor(0);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(170,452,"");
     setcolor(4);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(362,452,"JUEGA B");
     c=4;
   }
   do
   {
     lee_raton(&x,&y);
     /*gotoxy(1,1);printf("--->(%i,%i);\t",x,y); linea de ajuste*/
     if((15<=y)&&(y<=370))
       { if ((21<=x) && (x<=73) && boton_izdo())
	  {
	   ya=pon_ficha(1,c);
	   cj=1;
	  }
	 else if ((80<=x) && (x<=134) && boton_izdo())
	  {
	   ya=pon_ficha(2,c);
	   cj=2;
	  }
	 else if ((140<=x) && (x<=194) && boton_izdo())
	  {ya=pon_ficha(3,c);

	   cj=3;
	  }
	 else if ((200<=x) && (x<=255) && boton_izdo())
	  {ya=pon_ficha(4,c);

	   cj=4;
	  }
	 else if ((260<=x) && (x<=314) && boton_izdo())
	  {ya=pon_ficha(5,c);

	   cj=5;
	  }
	 else if ((319<=x) && (x<=374) && boton_izdo())
	  {ya=pon_ficha(6,c);

	   cj=6;
	  }
	 else if ((380<=x) && (x<=434) && boton_izdo())
	  {ya=pon_ficha(7,c);

	   cj=7;
	  }
	 else if ((440<=x) && (x<=494) && boton_izdo())
	  {ya=pon_ficha(8,c);

	   cj=8;
	  }
	 else if ((500<=x) && (x<=553) && boton_izdo())
	  {ya=pon_ficha(9,c);

	   cj=9;
	  }
	 else if ((560<=x) && (x<=614) && boton_izdo())
	  {ya=pon_ficha(10,c);

	   cj=10;
	  }
       }
       if ((248<=x) && (x<=390) && (429<=y) && (y<=444) && boton_izdo())
	  return 0;
     }while(ya!=1);

     return 1;
}

/*RUTINA DE COMPROBACION DE CADA JUGADA*/

int comprueba(int c,int f)
{
  int n,m,casillas;
  int patron;
  patron=tablero[10*(f-1)+c];
  n=c;
  m=f;
  casillas=0;
  /*comprob. vertical -abajo*/

  do
  { m++;
    casillas++;
  }while((casillas<4) && (m<=7) && (tablero[10*(m-1)+c]==patron));
  if(casillas==4)
      return 0;
  casillas=0;
  n=c;
  m=f;


  /*compro. horiz-derecha*/

  do
  { n++;
    casillas++;
  }while((casillas<4) && (n<=10) && (tablero[10*(f-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*comp. horizontal cualquiera*/
  do
  { n--;
    casillas++;
  }while((casillas<4) && (n>=1) && (tablero[10*(f-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;


  /*comp. diagonal-izq-abjo*/
  do
  { m++;
    n--;
    casillas++;
  }while((casillas<4) && (m<=7) && (n>=1) && (tablero[10*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*COMP. CUALQUIER DIAGONAL izq*/
  do
  { m--;
    n++;
    casillas++;
  }while((casillas<4) && (m>=1) && (n<=10) && (tablero[10*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;

  /*comp. diagonal der-abajo*/
   do
  { m++;
    n++;
    casillas++;
  }while((casillas<4) && (m<=7) && (n<=10) && (tablero[10*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*comprobar cualquier diagonal derecha*/
  do
  { m--;
    n--;
    casillas++;
  }while((casillas<4) && (m<=7) && (n<=10) && (tablero[10*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;

  return 1;

}

/*ANOTA CADA JUGADA GANADA EN EL MARCADOR DE CADA JUGADOR*/

void victoria(int jugador)
{     char *cadena;
      if(jugador==15)
      {	pga++;
	sprintf(cadena,"%i",pga);;
	setcolor(0);
	settextstyle(0,HORIZ_DIR,0);
	outtextxy(112,446,"");
	setcolor(15);
	settextstyle(0,HORIZ_DIR,0);
	outtextxy(112,446,cadena);
       }
       if(jugador==4)
       {
	pgb++;
	sprintf(cadena,"%i",pgb);
	setcolor(0);
	settextstyle(0,HORIZ_DIR,0);
	outtextxy(581,446,"");
	setcolor(4);
	settextstyle(0,HORIZ_DIR,0);
	outtextxy(581,446,cadena);
       }

}
/*LIMPIA CADENA DE CARACTERES*/

void vaciar(char linea[])
{
 int i=0;
 while (linea[i]!='\0')
  {
   linea[i]=' ';
   i++;
  }
linea[0]='\0';
}

/*FUNCION DE JUEGO EN CUALQUIER TAMAO*/

void maxitablero(int columnas, int filas)
{  int salir,m,n,enjuego,columna,fila,total,c,f;
   char ch;
   clrscr();
   total=columnas*filas;
   contador=0;
   tablero=(int *)malloc(total*sizeof(int));
      if(tablero==NULL)
	 { printf("error de memoria");
	   exit(1);
	 }
      for (c=0;c<=(columnas-1);c++) /*inicializa el tablero*/
      { for(f=1;f<=filas;f++)
	  tablero[columnas*(f-1)+c]=0;
      }
      if((columnas<=80)&&(filas<=29))
       {  for(f=1;f<=filas;f++)
	   { for (c=0;c<=(columnas-1);c++)
	       printf("%i",tablero[columnas*(f-1)+c]);
	     if(columnas!=80)
	       printf("\n");
	    }
       }
      else
       { setcolor(YELLOW);
	 settextstyle(0,HORIZ_DIR,4);
	 outtextxy(83,126,"MODO NO VISUAL");
       }

     ch='A';
      salir=0;
     do
     {
      do
      {
       printf("Numero de columna del jugador %c:",ch);
       scanf("%i",&columna);
       fila=filas;
       do
       {
	 if(tablero[columnas*(fila-1)+columna]==0)
	 {   tablero[columnas*(fila-1)+columna]=1;
	     salir=1;
	 }
	 fila--;
       }while((salir!=1) && (fila>=1));


      }while(salir!=1);
      contador++;
      ch='B';
      salir=0;
      clrscr();
      if(compru_maxi(columna,(fila+1),columnas,filas)==0)
       victoria(4);
      if((columnas<=80)&&(filas<=29))
       {  for(f=1;f<=filas;f++)
	   { for (c=0;c<=(columnas-1);c++)
	       printf("%i",tablero[columnas*(f-1)+c]);
	     if(columnas!=80)
	       printf("\n");
	    }
       }
      else
       { setcolor(YELLOW);
	 settextstyle(0,HORIZ_DIR,4);
	 outtextxy(83,126,"MODO NO VISUAL");
       }
    if(contador<(total-1))
    {  do
       {
	  printf("Numero de columna del jugador %c:",ch);
	  scanf("%i",&columna);
	  fila=filas;
	  do
	  {
	    if(tablero[columnas*(fila-1)+columna]==0)
	    {   tablero[columnas*(fila-1)+columna]=2;
		salir=1;
	    }
	    fila--;
	  }while((salir!=1) && (fila>=1));

       }while(salir!=1);
       ch='A';
       salir=0;
       clrscr();
       contador++;
       if((columnas<=80)&&(filas<=29))
       {  for(f=1;f<=filas;f++)
	   { for (c=0;c<=(columnas-1);c++)
	       printf("%i",tablero[columnas*(f-1)+c]);
	     if(columnas!=80)
	       printf("\n");
	    }
       }
       else
       { setcolor(YELLOW);
	 settextstyle(0,HORIZ_DIR,4);
	 outtextxy(83,126,"MODO NO VISUAL");
       }
      if(compru_maxi(columna,(fila+1),columnas,filas)==0)
	victoria(14);
   }
   }while(contador<(total-1) && columna!=ESC && fila!=ESC);
   if (contador==total)
       { if(pga>pgb)
	   {setcolor(YELLOW);
	    settextstyle(0,HORIZ_DIR,9);
	    outtextxy(83,126,"GANA A");
	    getch();
	    ganador(pga);
	   }
	 else if(pgb>pga)
	   { setcolor(YELLOW);
	     settextstyle(0,HORIZ_DIR,9);
	     outtextxy(83,126,"GANA B!!");
	     getch();
	     ganador(pgb);
	   }
	 else
	   {
	   setcolor(RED);
	   settextstyle(0,HORIZ_DIR,9);
	   outtextxy(83,126,"TABLAS");
	   getch();
	   }
       }

}

/*COMPROBACION DE JUGADA EN CUALQUIER TABLERO*/

int compru_maxi(int c,int f, int maxc, int maxf)
{ int n,m,casillas,patron;
  patron=tablero[maxc*(f-1)+c];
  n=c;
  m=f;
  casillas=0;
  /*comprob. vertical -abajo*/

  do
  { m++;
    casillas++;
  }while((casillas<4) && (m<=maxf) && (tablero[maxc*(m-1)+c]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;


  /*compro. horiz-derecha*/

  do
  { n++;
    casillas++;
  }while((casillas<4) && (n<=maxc) && (tablero[maxc*(f-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*comp. horizontal cualquiera*/
  do
  { n--;
    casillas++;
  }while((casillas<4) && (n>=1) && (tablero[maxc*(f-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;


  /*comp. diagonal-izq-abjo*/
  do
  { m++;
    n--;
    casillas++;
  }while((casillas<4) && (m<=maxf) && (n>=1) && (tablero[maxc*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*COMP. CUALQUIER DIAGONAL izq*/
  do
  { m--;
    n++;
    casillas++;
  }while((casillas<4) && (m>=1) && (n<=maxc) && (tablero[maxc*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;

  /*comp. diagonal der-abajo*/
  do
  { m++;
    n++;
    casillas++;
  }while((casillas<4) && (m<=maxf) && (n<=maxc) && (tablero[maxc*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas--;
  n=c;
  m=f;
  /*comprobar cualquier diagonal derecha*/
  do
  { m--;
    n--;
    casillas++;
  }while((casillas<4) && (m<=maxf) && (n<=maxc) && (tablero[maxc*(m-1)+n]==patron));
  if(casillas==4)
    return 0;
  casillas=0;
  n=c;
  m=f;
  return 1;

}

/*RUTINA PSEUDOALEATORIA DE SIMULACION DE JUEGO*/

void juega_maquina(int columnas)
{    int c,r,p;
     setcolor(0);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(170,452,"");
     setcolor(4);
     settextstyle(0,HORIZ_DIR,2);
     outtextxy(362,452,"MAQUINA");
     randomize();
     c=cj;
     p=random(4);
     switch(p)
     {
     case 0: r=pon_ficha(c,4);

     case 1: if(r!=1)
	     { if(c!=1)
	       r=pon_ficha((c-1),4);
	     }
     case 2: if(r!=1)
	     { if(c!=10)
	       r=pon_ficha((c+1),4);
	     }
     case 3:  if(r!=1)
	      {
	      randomize();
	      while(r!=1)
	      {
		c=random(columnas);
		c++;
		r=pon_ficha(c,4);
	      }
	      }
	      break;

     }
}
/*DIBUJA EL MARCO DE LOS RECORDS*/

void scores()
{

  char num[31]=" ";
  char score[6]=" ";
  char fechas[11]=" ";
  int L=102,C=55,q;
  cleardevice();
  settextstyle (0,HORIZ_DIR,3);
  setcolor(1);
  outtextxy (148,3,"MEJORES CONECTORES");
  setcolor(15);
  outtextxy (145,0,"MEJORES CONECTORES");
  setcolor(1);
  setfillstyle(1,0);
  bar3d(35,60,80,75,0,0);
  bar3d(100,60,350,75,0,0);
  bar3d(370,60,480,75,0,0);
  bar3d(500,60,600,75,0,0);
  bar3d(35,85,80,ventanay-60,0,0);
  bar3d(100,85,350,ventanay-60,0,0);
  bar3d(370,85,480,ventanay-60,0,0);
  bar3d(500,85,600,ventanay-60,0,0);
  setcolor(14);
  settextstyle (0,HORIZ_DIR,1);
  outtextxy (38,65,"LUGAR");
  outtextxy (200,65,"NOMBRE");
  outtextxy (400,65,"PUNTAJE");
  outtextxy (530,65,"FECHA");

  for (q=0;q<5;q++)
     {
      vaciar(num); vaciar(score); vaciar (fechas);
      sprintf(score,"%i",jugadores[q].puntaje);
      sprintf(fechas,"%i/%i/%i",jugadores[q].f_juego.dia,jugadores[q].f_juego.mes,jugadores[q].f_juego.ano);
      sprintf(num,"%i    %s",(q+1),jugadores[q].nombre);
      settextstyle (0,HORIZ_DIR,2);
      setcolor(1);
      outtextxy(C,L,num);
      outtextxy(C+322,L,score);
      settextstyle (0,HORIZ_DIR,1);
      outtextxy(C+452,L,fechas);
      setcolor(15);
      settextstyle (0,HORIZ_DIR,2);
      outtextxy(C-2,L-2,num);
      outtextxy(C+320,L-2,score);
      settextstyle (0,HORIZ_DIR,1);
      outtextxy(C+450,L-2,fechas);
      L+=55;
     }
settextstyle (0,HORIZ_DIR,2);
outtextxy (40,440,"Presiona una tecla para continuar...");
getch();
}

/*TOMA LOS DATOS DEL NUEVO GANADOR*/

void ganador(int puntos)
{   struct date hoy;
    int q;
    struct JUGADOR leer,auxiliar;
    oculta_raton();
    cleardevice();
    for(q=0;q<=4;q++)
      { if(puntos>=jugadores[q].puntaje)
	{

	 vaciar(jugadores[q].nombre);
	 int car,i,cc;
	 char mostrar[2]=" ";
	 char L;
	 strcpy(leer.nombre,jugadores[q].nombre);
	 leer.puntaje=jugadores[q].puntaje;
	 jugadores[q].puntaje=puntos;
	 puntos=0;
	 cleardevice();
	 getdate (&hoy);
	 leer.f_juego.dia=jugadores[q].f_juego.dia;
	 leer.f_juego.mes=jugadores[q].f_juego.mes;
	 leer.f_juego.ano=jugadores[q].f_juego.ano;
	 jugadores[q].f_juego.dia=hoy.da_day;
	 jugadores[q].f_juego.mes=hoy.da_mon;
	 jugadores[q].f_juego.ano=hoy.da_year;
	 setcolor(10);
	 setfillstyle(1,0);
	 settextstyle(0,HORIZ_DIR,1);
	 bar3d(160,260,480,290,0,0);
	 outtextxy (160,230,"TIENES UN RECORD");
	 outtextxy (160,250,"Escribe aqu tu nombre:");
	 i=0;
	 cc=180;
	 do{
	 L=getch();
	 car=L;
	 if (car!=13)
	   {
	       if (car!=8)
	       {
	       vaciar(mostrar);
	       setcolor(15);
	       settextstyle(0,HORIZ_DIR,2);
	       sprintf(mostrar,"%c",L);
	       outtextxy(cc,265,mostrar);
	       jugadores[q].nombre[i]=L;
	       cc+=15; i++;
	       }
	     else
	       {
		if (i>0)
		  {
		  i--; cc-=15;
		  outtextxy(cc,265," ");
		  }
		else outtextxy(180,265," ");
	       }
	   }
	 }while(car!=13);
	  q++;
	  while(q<=4)
	  { strcpy(auxiliar.nombre,jugadores[q].nombre);
	    strcpy(jugadores[q].nombre,leer.nombre);
	    strcpy(leer.nombre,auxiliar.nombre);
	    auxiliar.puntaje=jugadores[q].puntaje;
	    jugadores[q].puntaje=leer.puntaje;
	    leer.puntaje=auxiliar.puntaje;
	    auxiliar.f_juego.dia=jugadores[q].f_juego.dia;
	    auxiliar.f_juego.mes=jugadores[q].f_juego.mes;
	    auxiliar.f_juego.ano=jugadores[q].f_juego.ano;
	    jugadores[q].f_juego.dia=leer.f_juego.dia;
	    jugadores[q].f_juego.mes=leer.f_juego.mes;
	    jugadores[q].f_juego.ano=leer.f_juego.ano;
	    leer.f_juego.dia=auxiliar.f_juego.dia;
	    leer.f_juego.mes=auxiliar.f_juego.mes;
	    leer.f_juego.ano=auxiliar.f_juego.ano;
	    q++;
	  }
       }
     }
     visualiza_raton();
}

/*MUESTRA LA AYUDA*/

void ayuda()
{
  int col,fila;
  col=160;
  fila=185;
  cleardevice();
  setcolor(1);
  bar3d(40,40,630,ventanay,0,0);
  settextstyle (0,HORIZ_DIR,3);
  outtextxy (125,15,"AYUDA SOBRE CONECTOR");
  setcolor (15);
  outtextxy (120,10,"AYUDA SOBRE CONECTOR");
  setcolor(15);
  settextstyle(0,HORIZ_DIR,1);
  outtextxy(60,62,"Este juego consiste en el clasico juego de mesa llamado conecta-4 y");
  outtextxy(60,72,"dispone de las opciones tanto de variar de tablero, como  de  uno o");
  outtextxy(60,82,"dos jugadores. Dentro de la opcion de multitablero, a partir de 80 ");
  outtextxy(60,92,"columnas o 29 filas no esta disponible la visualizacion del");
  outtextxy(60,102,"tablero.Asi mismo tampoco esta disponible la opcin de 1 jugador.");
  outtextxy(60,112,"Cada vez que llega al final de una columna suena un beep.Puede ");
  outtextxy(60,122,"tardar la maquina algun tiempo en colocar su ficha.");
  settextstyle(0,HORIZ_DIR,2);
     outtextxy (col,fila,"1. JUGAR TABLERO CLASICO");
     outtextxy (col,fila+25,"2. JUGAR CUALQUIER TABLERO");
     outtextxy (col,fila+50,"3. LOS MAS LISTOS");
     outtextxy (col,fila+75,"4. COMO FUNCIONA");
     outtextxy (col,fila+100,"5. SALIR");

  settextstyle (0,HORIZ_DIR,2);
  outtextxy (40,440,"Presiona una tecla para continuar...");
  getch();
}

/*FIN DE JUEGO*/

void fin()
{
 int son=100;
 cleardevice();
 carita();
 setcolor (1);
 settextstyle (0,HORIZ_DIR,4);
 outtextxy (180,95,"GAME OVER");
 setcolor(15);
 outtextxy (175,90,"GAME OVER");
 sound(son*2);
 delay (500);
 nosound();
 sound(son);
 delay (1000);
 nosound();
 delay(800);
}

